-- ADA95.ADA   Ver. 4.01   2001-SEP-10   Copyright 1988-2001 John J. Herro
--
-- SOFTWARE INNOVATIONS TECHNOLOGY          www.adatutor.com
-- 1083 MANDARIN DR NE
-- PALM BAY FL 32905-4706                   john@adatutor.com
--
-- (321) 951-0233
--
-- Version of CUSTOM_IO for Ada 95 compilers.  Compile this before compiling
-- ADATU401.ADA.
--

with Ada.Text_IO;
package Custom_IO is
  type Color is (Black, Red, Green, Yellow, Blue, Magenta, Cyan, White);
  Foregrnd_Color   : Color;
  Backgrnd_Color   : Color;
  Border_Color     : Color;
  Fore_Color_Digit : Character;
  Back_Color_Digit : Character;
  Esc              : constant Character := Character'Val(27);
  Normal_Colors    : String(1 .. 10) := Esc & "[0;37;40m";
  Clear_Scrn       : constant String := Esc & "[H" & Esc & "[2J";

  procedure Set_Border_Color (To      : in  Color);
  procedure Get              (Char    : out Character);
  procedure Put              (Char    : in  Character);
  procedure Put              (Str     : in  String);
  procedure Put_Line         (Str     : in  String);
  procedure Get_Line         (Str     : out String;
                              Last    : out Natural);
  procedure New_Line         (Spacing : in  Ada.Text_IO.Positive_Count := 1);
end Custom_IO;

package body Custom_IO is
  procedure Set_Border_Color(To : in Color) is
      --
      -- This is a dummy procedure.  If your PC Ada compiler allows interrupt
      -- calls or assembly language, you may want to write code to call
      -- interrupt 10 hex.  (See JANUS16.PKG, JANUS32.PKG, and OPEN.ADA for
      -- examples.)  Before the call, set register AH to service number 0B hex,
      -- set BH to zero, and set BL to Color_Number(To), where Color_Number is
      -- declared below.  Note that the integers in Color_Number are bit
      -- reversed from the integers defining foreground and background colors
      -- in ANSI escape sequences.  Note also that some color PCs don't have
      -- separate border colors.
      --
     Color_Number : constant array(Color) of Integer :=
         (Black   => 0,   Red     => 4,   Green   => 2,   Yellow  => 6,
          Blue    => 1,   Magenta => 5,   Cyan    => 3,   White   => 7);
  begin
     null;
  end Set_Border_Color;
  procedure Get      (Char    : out Character) renames
                                                     Ada.Text_IO.Get_Immediate;
  procedure Put      (Char    : in  Character) renames Ada.Text_IO.Put;
  procedure Put      (Str     : in  String)    renames Ada.Text_IO.Put;
  procedure Put_Line (Str     : in  String)    renames Ada.Text_IO.Put_Line;
  procedure Get_Line (Str     : out String;
                      Last    : out Natural)   renames Ada.Text_IO.Get_Line;
  procedure New_Line (Spacing : in  Ada.Text_IO.Positive_Count := 1) renames
                                                          Ada.Text_IO.New_Line;
end Custom_IO;
