-- UNIX.ADA   Ver. 4.01   2001-SEP-10   Copyright 1988-2001 John J. Herro
--
-- SOFTWARE INNOVATIONS TECHNOLOGY          www.adatutor.com
-- 1083 MANDARIN DR NE
-- PALM BAY FL 32905-4706                   john@adatutor.com
--
-- (321) 951-0233
--
-- Compile this before compiling ADATU401.ADA on a UNIX based system.  You must
-- also compile ONECHAR.C or ALTCHAR.C with a C compiler before linking.  See
-- the first page of ADATU401.ADA for more details.
--
-- If you have an Ada 95 compiler, we recommend compiling ADA95.ADA instead of
-- one of the .C files and UNIX.ADA.
--
-- This code is written in Ada 83 and will compile on Ada 83 and Ada 95
-- compilers.
--

with Text_IO;
package Custom_IO is
  type Color is (Black, Red, Green, Yellow, Blue, Magenta, Cyan, White);
  Foregrnd_Color   : Color;
  Backgrnd_Color   : Color;
  Border_Color     : Color;
  Fore_Color_Digit : Character;
  Back_Color_Digit : Character;
  Esc              : constant Character := Character'Val(27);
  Normal_Colors    : String(1 .. 10) := Esc & "[0;37;40m";
  Clear_Scrn       : constant String := Esc & "[H" & Esc & "[2J";

  procedure Set_Border_Color (To   : in  Color);
  procedure Get              (Char : out Character);
  procedure Put              (Char : in  Character)   renames Text_IO.Put;
  procedure Put              (Str  : in  String)      renames Text_IO.Put;
  procedure Put_Line         (Str  : in  String)      renames Text_IO.Put_Line;
  procedure Get_Line         (Str  : out String;
                              Last : out Natural)     renames Text_IO.Get_Line;
  procedure New_Line      (Spacing : in  Text_IO.Count := 1)
                                                      renames Text_IO.New_Line;
end Custom_IO;

package body Custom_IO is
  procedure Set_Border_Color(To : in Color) is
     -- Dummy procedure for computers other than PCs.
  begin
    null;
  end Set_Border_Color;

  procedure Get(Char : out Character) is
    function Onechar return Character;
    pragma Interface (C, Onechar);              -- Pragma Interface is used for
  begin                                         -- compatibility with Ada 83.
    Char := Onechar;
  end Get;
end Custom_IO;
